/****************************************************************************
 *	Copylight(C) 2014 Omiya-Giken,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	Form1.cs
 *
 *	@brief	irMagician client.
 *
 *	@author	Osamu OHASHI
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Text.RegularExpressions;
using System.Diagnostics;
using Codeplex.Data;
using System.Runtime.Serialization;
using System.IO;
using System.Net;
using Microsoft.VisualBasic.FileIO;




namespace irMagician_sample
{

    public partial class Form1 : Form
	{
        static public int receiveStatus;
        static public string irDataStr;

        static public int recordNumber;
        static public int postScale;
        static List<int> irDataList = new List<int>();

		private delegate void Delegate_RcvDataToTextBox( string data );

		/****************************************************************************/
		/*!
		 *	@brief	Constructor.
		 *
		 *	@param	None.
		 *
		 *	@retval	None.
		 */
		public Form1()
		{
			InitializeComponent();
		}

        public class ir10Data
        {
            public int ir10 { get; set; }
        }

		/****************************************************************************/
		/*!
		 *	@brief	Dialog initialize.
		 *
		 *	@param	[in]	sender	.
		 *	@param	[in]	e		.
		 *
		 *	@retval	Ȃ.
		 */
		private void Form1_Load(object sender, EventArgs e)
		{
			//! Get aviilable serial port array.
			string[] PortList = SerialPort.GetPortNames();

			cmbPortName.Items.Clear();

			//! Set serial port to combo-box.
			foreach( string PortName in PortList ){
				cmbPortName.Items.Add( PortName );
			}
			if( cmbPortName.Items.Count > 0 ){
				cmbPortName.SelectedIndex = 0;
			}

            Form1.receiveStatus = 0;

            listViewirMagician.View = View.Details;
            listViewirMagician.FullRowSelect = true;
            listViewirMagician.GridLines = true;
            listViewirMagician.Sorting = SortOrder.Ascending;
            listViewirMagician.View = View.Details;

            // Column header creation
            ColumnHeader columnName = new ColumnHeader();
            ColumnHeader columnURI = new ColumnHeader();
            ColumnHeader columnAction = new ColumnHeader();

            columnName.Text = "Title";
            columnName.Width = 150;
            listViewirMagician.Columns.Add(columnName);

            columnURI.Text = "File/URI";
            columnURI.Width = 230;
            listViewirMagician.Columns.Add(columnURI);

//            columnAction.Text = "Action";
//            columnAction.Width = 60;
//            listViewirMagician.Columns.Add(columnAction);
        
            // Read CSV file
            TextFieldParser parser = new TextFieldParser("irMagician.csv", System.Text.Encoding.GetEncoding("Shift_JIS"));
            using (parser){
                parser.TextFieldType = FieldType.Delimited;
                parser.SetDelimiters(","); // ؂蕶̓R}

                // parser.HasFieldsEnclosedInQuotes = false;
                // parser.TrimWhiteSpace = false;

                while (!parser.EndOfData){
                    string[] row = parser.ReadFields(); // 1sǂݍ
                    listViewirMagician.Items.Add(new ListViewItem(row));
                }
            }

            listViewirMagician.HoverSelection = true;
            listViewirMagician.Activation = ItemActivation.OneClick;
            listViewirMagician.ItemActivate += new EventHandler(listViewirMagician_ItemActivate);



			// Clear recieve box.
			rcvTextBox.Clear();

		}

        private void listViewirMagician_ItemActivate(object sender, EventArgs e)
        {
            ListView lv = (ListView)sender;

//            MessageBox.Show(lv.SelectedItems[0].SubItems[1].Text);
            sendIrData(lv.SelectedItems[0].SubItems[1].Text);
        }


		/****************************************************************************/
		/*!
		 *	@brief	Dialog close.
		 *
		 *	@param	[in]	sender	
		 *	@param	[in]	e		
		 *
		 *	@retval	None.
		 */
		private void Form1_FormClosed(object sender, FormClosedEventArgs e)
		{
			if( serialPort1.IsOpen ){
				serialPort1.Close();
			}
		}


		/****************************************************************************/
		/*!
		 *	@brief	[Connect]/[Disconnect] button with serial port open/close.
		 *
		 *	@param	[in]	sender	
		 *	@param	[in]	e		
		 *
		 *	@retval	None.
		 */
		private void connectButton_Click(object sender, EventArgs e)
		{

			if( serialPort1.IsOpen == true ){
				//! Close serial port.
				serialPort1.Close();

				//! Switch Disconnect to Connect of Button.
				connectButton.Text = "Connect";
			}else{
				//! Opened serial port from combo-box.
				serialPort1.PortName = cmbPortName.SelectedItem.ToString();

				serialPort1.BaudRate = 9600;
				serialPort1.DataBits = 8;
				serialPort1.Parity = Parity.None;
				serialPort1.StopBits = StopBits.One;
                serialPort1.Handshake = Handshake.None;
				serialPort1.Encoding = Encoding.ASCII;

				try {
					//! Open serial port.
					serialPort1.Open();

                    //! Switch Connect to Disconnect of Button.
					connectButton.Text = "Disconnect";
				}
				catch ( Exception ex ){
					MessageBox.Show(ex.Message);
				}
			}
		}

		/****************************************************************************/
        private void capButton_Click_1(object sender, EventArgs e)
        {
			//! Check serial port.
			if( serialPort1.IsOpen == false ){
				return;
			}
            try
            {
                Byte[] dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes("C\r\n");
                serialPort1.Write(dat, 0, dat.GetLength(0));
                receiveStatus = 1;
                System.Threading.Thread.Sleep(50);

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void playButton_Click(object sender, EventArgs e)
        {
            //! Check serial port.
            if (serialPort1.IsOpen == false){
                return;
            }
            try
            {
                Byte[] dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes("P\r\n");
                serialPort1.Write(dat, 0, dat.GetLength(0));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void readButton_Click(object sender, EventArgs e)
        {
            int n, bank, pos;
            //! Check serial port.
            if (serialPort1.IsOpen == false){
                return;
            }
            try
            {
                irDataStr = "";
                String txDataStr = "I,1\r\n";
                Byte[] dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes(txDataStr);
                receiveStatus = 3;

                for (n = 0; n < recordNumber; n++){
                    bank = n / 64;
                    pos = n % 64;
                    if (pos == 0){
                        // Bank set
                        txDataStr = "B," + bank.ToString("d") + "\r\n";
                        dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes(txDataStr);
                        serialPort1.Write(dat, 0, dat.GetLength(0));
                    }
                    //Data read
                    txDataStr = "D," + pos.ToString("d") + "\r\n";
                    dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes(txDataStr);
                    serialPort1.Write(dat, 0, dat.GetLength(0));
//                    System.Threading.Thread.Sleep(1);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void saveButton_Click(object sender, EventArgs e)
        {
            if (receiveStatus >= 3){
                // irData preparation
                string[] aryStr = irDataStr.Split(' ');
                for (int i = 0; i < aryStr.Length - 1;i++ ){
                    irDataList.Add(Convert.ToInt32(aryStr[i], 16));
                }

                var obj = new
                {
                    postscale = 100,
                    freq = 38,
                    data = irDataList,
                    format = "raw"
                };

                // SaveFileDialog
                SaveFileDialog sfd = new SaveFileDialog();

                sfd.FileName = "New.json";  // Create default file name
                sfd.InitialDirectory = @"C:\"; // Default folder
                sfd.Filter = "JSON file(*.json)|*.json|all files(*.*)|*.*";
                sfd.FilterIndex = 2;
//                sfd.Title = "ۑ̃t@CIĂ";
                sfd.RestoreDirectory = true; // Recover current folder
                if (sfd.ShowDialog() == DialogResult.OK)
                {
                    //OK{^NbNꂽƂ
                    //Iꂽt@C\
                    Console.WriteLine(sfd.FileName);

                    var jsonStringFromObj = DynamicJson.Serialize(obj);
                    Encoding asciiEnc = Encoding.GetEncoding("ASCII");
                    StreamWriter writer = new StreamWriter(sfd.FileName, true, asciiEnc);
                    writer.WriteLine(jsonStringFromObj);
                    writer.Close();
                }
            }
        }


        /****************************************************************************/
		/*!
		 *	@brief	Data receive event.
		 *
		 *	@param	[in]	sender	
		 *	@param	[in]	e		
		 *
		 *	@retval	None.
		 */
		private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
		{
            Regex re;
            //! Check serial port.
			if( serialPort1.IsOpen == false ){
				return;
			}
			try {
				//! Receive data.
                SerialPort port = (SerialPort)sender;
                byte[] buf = new byte[1024];
                int len = port.Read(buf, 0, 1024);
                string data = Encoding.GetEncoding("ASCII").GetString(buf, 0, len);

                switch (receiveStatus){
                    case 0:
                        break;
                    case 1:
                        if (data == "..."){
                            receiveStatus = 2;
                            return;
                        }
                        else{
                            // error
                        }
                        break;
                    case 2:
                        if (data == " Time Out !\r\n"){
                            MessageBox.Show("Time Out !!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                        else{
                            re = new Regex(@"[^0-9]");
                            recordNumber = int.Parse(re.Replace(data, ""));
                            receiveStatus = 0;
                        }
                        break;
                    case 3:
                        irDataStr += data;
                        break;
                    case 4:
                        break;
                    default:
                        break;
                }

				//! Write receive data to text box.
				Invoke( new Delegate_RcvDataToTextBox( RcvDataToTextBox ), new Object[] {data} );
			}
			catch ( Exception ex ){
				MessageBox.Show( ex.Message );
			}
		}

		/****************************************************************************/
		/*!
		 *	@brief	Write receive data to text box.
		 *
		 *	@param	[in]	data	receive data.
		 *
		 *	@retval	None.
		 */
		private void RcvDataToTextBox( string data )
		{
			//! Append receive data to end of text box.
			if( data != null ){
				rcvTextBox.AppendText( data );
			}
		}

        private void rcvTextBox_TextChanged(object sender, EventArgs e)
        {

        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void Test_Click(object sender, EventArgs e)
        {
//            sendIrData("http://www.omiya-giken.com/irMagician/irData/Toshiba/CeilingLight/FRC-186T/LightOff.json");
            sendIrData("file:///c:\\Scene.json");
        }

        private void sendIrData(String aURL)
        {
            // json file downloading
            System.Net.WebClient wc = new System.Net.WebClient();
            string readJson = wc.DownloadString(aURL);
            dynamic jsonString = DynamicJson.Parse(readJson);

            // Downloaded json file to object
            irDataList = jsonString.data;

            // Set object to irMagician via serial communication
            recordNumber = irDataList.Count;
            postScale = (int)jsonString.postscale;

            int n, bank, pos;
            //! Check serial port.
            if (serialPort1.IsOpen == false){
                return;
            }
            try
            {
                irDataStr = "";
                String txDataStr = "I,1\r\n";
                Byte[] dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes(txDataStr);
                receiveStatus = 3;

                // Send Record number
                txDataStr = "n," + recordNumber.ToString("d") + "\r\n";
                dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes(txDataStr);
                serialPort1.Write(dat, 0, dat.GetLength(0));

                // Send Post scale
                txDataStr = "K," + postScale.ToString("d") + "\r\n";
                dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes(txDataStr);
                serialPort1.Write(dat, 0, dat.GetLength(0));

                // Write irMagician data
                for (n = 0; n < recordNumber; n++){
                    bank = n / 64;
                    pos = n % 64;
                    if (pos == 0){
                        // Bank set
                        txDataStr = "b," + bank.ToString("d") + "\r\n";
                        dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes(txDataStr);
                        serialPort1.Write(dat, 0, dat.GetLength(0));
//                        System.Threading.Thread.Sleep(1);
                    }
                    // Write data
                    txDataStr = "w," + pos.ToString("d") + "," + irDataList[pos + bank * 64].ToString("d") + "\r\n";
                    dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes(txDataStr);
                    serialPort1.Write(dat, 0, dat.GetLength(0));
//                    System.Threading.Thread.Sleep(1);
                }
                // Send Play command
                dat = System.Text.Encoding.GetEncoding("ASCII").GetBytes("p\r\n");
                serialPort1.Write(dat, 0, dat.GetLength(0));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

	}
}

/* End of file */
